import LifecycleUnit from '../../lib/src/lifecycle/Unit.ts'
import {CLIService} from './service/CLI.service.ts'
import {Unit} from '../../lib/src/lifecycle/decorators.ts'
import {UsageDirective} from './directive/UsageDirective.ts'
import {AboutDirective} from './directive/AboutDirective.ts'

@Unit()
export default class CLIUnit extends LifecycleUnit {
    constructor(
        protected readonly cli: CLIService,
    ) { super() }

    public async up() {
        this.cli.register_directive(this.make(UsageDirective))
        this.cli.register_directive(this.make(AboutDirective))
    }
}
