import {Directive} from './Directive.ts'
import {Injectable} from '../../../di/src/decorator/Injection.ts'
import {CLIService} from '../service/CLI.service.ts'

@Injectable()
export class AboutDirective extends Directive {
    public readonly keyword = 'about'
    public readonly help = 'Display information about Daton'

    constructor(
        protected readonly cli: CLIService,
    ) { super() }

    public async invoke() {
        if ( this.cli.show_logo() ) {
            console.log('')
            console.log(this.cli.get_logo())
        }

        [
            '',
            'Daton is an opinionated application framework written for Deno. It provides a rich library of utilities, an ORM, dependency injector, routing stack, and logic for controllers, models, middleware, and configuration.',
            '',
            `Daton was created by and is © ${(new Date).getFullYear()} Garrett Mills. It is licensed for use by the terms of the MIT license.`,
            '',
            'Source code: https://code.garrettmills.dev/garrettmills/daton',
            '',
        ].map(x => console.log(x))
    }
}
